//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Unit1.h"
#include "ASMVars.h"
//#include <math.h>
//#include <algorithm>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "ievect"
#pragma link "ieview"
#pragma link "imageenview"
#pragma link "ieopensavedlg"
#pragma link "cspin"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
srcMap = 0;
dstMap = 0;
maskMap = 0;
hardMaskMap = 0;
undoMap = 0;
paca = 0;
PaintView->SelectionMaskDepth = 8;
//
int i, cTop = 30, cLeft = 26, spacing = 3, lWidth = 38, lHeight = 30;
// creation logic
caLogic[0] = "OR";
caLogic[1] = "AND";
caLogic[2] = "XOR";
caLogic[3] = "NAND";
caLogic[4] = "TRUE";
for (i = 0; i < 9; i++)
	{
	caCreation[i] = new TPanel(this);
	caCreation[i]->AutoSize = false;
	caCreation[i]->Parent = panCaCreation;
	caCreation[i]->Width  = lWidth;
	caCreation[i]->Height = lHeight;
	caCreation[i]->Color = clSkyBlue;
	caCreation[i]->BorderStyle = bsSingle;
	caCreation[i]->BevelOuter = bvNone;
	caCreation[i]->Ctl3D = false;
	caCreation[i]->Caption = "OR";
	caCreation[i]->Tag = 0;
	//
	if (i > 0)
	   {
	   if (i % 3 == 0)
		  {
		  cLeft = 26;
		  cTop += lHeight + spacing;
		  }
	   else
		  cLeft += lWidth + spacing;
	   }
	caCreation[i]->Top  = cTop;
	caCreation[i]->Left = cLeft;
	if (i == 4)
	   {
	   caCreation[i]->Color = clBtnFace;
	   caCreation[i]->Caption = "O";
	   }
	else
	   {
	   caCreation[i]->OnClick = caLogicClick;
	   }
	}
panStatus->Caption = "";
PaintView->OnMouseDown = 0;
PaintView->OnMouseMove = 0;
PaintView->OnMouseUp = 0;
_mouseDown = false;
_manualSeedDone = false;
defaultCursor = PaintView->Cursor;
currMI = PaintView->MouseInteract;
chkManual->Checked = false;
btnSelect->Visible = false;
btnSeed->Visible = false;
}
//---------------------------------------------------------------------------
__fastcall TForm1::~TForm1(void)
{
if (srcMap)
   {
   delete srcMap;
   delete dstMap;
   delete undoMap;
   }
if (maskMap)
   delete maskMap;
if (hardMaskMap)
   delete hardMaskMap;
if (paca)
   delete paca;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormShow(TObject *Sender)
{
comboSeed->ItemIndex = 0;
comboSeedChange(this);
chkMirrorClick(this);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::caLogicClick(TObject *Sender)
{
TPanel *lab = static_cast <TPanel*>(Sender);
lab->Tag++;
if (lab->Tag > 4)
	lab->Tag = 0;
lab->Caption = caLogic[lab->Tag];
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnLoadClick(TObject *Sender)
{
// load image
if (OpenDialog->Execute())
   {
   PaintView->IO->LoadFromFile(OpenDialog->FileName);
   if (srcMap)
	  {
	  delete srcMap;
	  delete dstMap;
	  delete undoMap;
	  }
   if (paca)
	  {
	  delete paca;
	  paca = 0;
	  }
   srcMap = new TIEBitmap(PaintView->IEBitmap);
   dstMap = new TIEBitmap(PaintView->IEBitmap);
   undoMap = new TIEBitmap(PaintView->IEBitmap);
   PaintView->DeSelect();
   PaintView->Zoom = 100.0;
   btnSelectClick(this);
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnSaveClick(TObject *Sender)
{
// save image
if (SaveDialog->Execute())
   PaintView->IO->SaveToFile(SaveDialog->FileName);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnInpaintClick(TObject *Sender)
{
// inpainting
if (!srcMap)
   return;
if (PaintView->Selected)
   {
   // mask
   prepareMask();
   processInpaint();
   delete maskMap;
   maskMap = 0;
   if (hardMaskMap)
	  delete hardMaskMap;
   hardMaskMap = 0;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnSeedClick(TObject *Sender)
{
// seed and show grips
if (!srcMap)
   return;
if (PaintView->Selected)
   {
   // mask
   prepareMask();
   processSeed();
   delete maskMap;
   maskMap = 0;
   if (hardMaskMap)
	  delete hardMaskMap;
   hardMaskMap = 0;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnUndoClick(TObject *Sender)
{
if (srcMap)
   {
   undoMap->CopyRectTo(srcMap, 0, 0, 0, 0, srcMap->Width, srcMap->Height);
   srcMap->CopyRectTo(PaintView->IEBitmap, 0, 0, 0, 0, srcMap->Width, srcMap->Height);
   srcMap->CopyRectTo(dstMap, 0, 0, 0, 0, srcMap->Width, srcMap->Height);
   PaintView->Update();
   }
}
//---------------------------------------------------------------------------
bool __fastcall TForm1::processInpaint(void)
{
TTime stime = Time(), etime, duration;
panStatus->Caption = "  Processing... ";
panStatus->Refresh();
if (!paca)
   paca = new TPaca(srcMap, dstMap);
for (int i = 0; i < 9; i++)
	creationOps[i] = caCreation[i]->Tag;
int seedStyle;
switch (comboSeed->ItemIndex)
  {
  case 0:
	   seedStyle = SEED_EXTREMA_H;
	   break;
  case 1:
	   seedStyle = SEED_EXTREMA_V;
	   break;
  case 2:
	   seedStyle = SEED_EXTREMA_HV;
	   break;
  case 3:
	   seedStyle = SEED_GRID_FULL;
	   break;
  default:
	   seedStyle = SEED_GRID_NOC;
	   break;
  }
bool adjustPull = (chkAdjustPull->Checked && !chkMirror->Checked);
int maxIters = 5;  // not too much onion peeling (too much tears)
bool manualPass = false;
paca->Prepare(maskMap, hardMaskMap, &selRect);
if (_manualSeedDone)
   {
   TPoint *targetSeed = new TPoint[paca->SiteCount];
   TPoint *sourceSeed = new TPoint[paca->SiteCount];
   int siteIndex;
   for (int i = 0; i < PaintView->ObjectsCount; i++)
	   {
	   if (PaintView->ObjName[i] == "target")
		  {
		  siteIndex = PaintView->ObjID[i];
		  targetSeed[siteIndex].x = PaintView->ObjLeft[i] + (_gripSize>>1);
		  targetSeed[siteIndex].y = (srcMap->Height - 1) - (PaintView->ObjTop[i] + (_gripSize>>1));
		  }
	   else if (PaintView->ObjName[i] == "source")
		  {
		  siteIndex = PaintView->ObjID[i];
		  sourceSeed[siteIndex].x = PaintView->ObjLeft[i] + (_gripSize>>1);
		  sourceSeed[siteIndex].y = (srcMap->Height - 1) - (PaintView->ObjTop[i] + (_gripSize>>1));
		  }
	   }
   paca->ReseedManual(targetSeed, sourceSeed);
   delete []targetSeed;
   delete []sourceSeed;
   maxIters--;
   manualPass = true;
   }
if (!manualPass)
	{
	if (!paca->Seed(seedStyle, editSubdivision->Value, editSourcePush->Value, editTargetPull->Value, adjustPull ))
	   return false;
	}
while (maxIters-- >0)
   {
   if (paca->Execute(editMaxIter->Value, chkMirror->Checked, comboPixelOutput->ItemIndex, comboDistance->ItemIndex
					 , creationOps, comboMatrixMutation->ItemIndex, editMutateStep->Value
					 , chkVarProbability->Checked))
	  break;
   if (!chkOnionPeel->Checked)
	  break;
   if (paca->OnionPeel())
	  break;
   }
//
paca->PostProcess(chkFillHoles->Checked, editCollisionPass->Value, editBorderSmooth->Value);
dstMap->CopyRectTo(PaintView->IEBitmap, 0, 0, 0, 0, srcMap->Width, srcMap->Height);
dstMap->CopyRectTo(srcMap, 0, 0, 0, 0, srcMap->Width, srcMap->Height);
PaintView->Update();
etime = Time();
duration = etime - stime;
panStatus->Caption = " Done! Time elapsed: "+duration.FormatString("hh:nn:ss.zzzz");
// replace value if average adjustment is performed - info only
if (chkAdjustPull->Checked && !chkMirror->Checked)
   panStatus->Caption = panStatus->Caption + " ,adjust pull value = " + IntToStr(paca->AverageAdjustment);
return true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::comboSeedChange(TObject *Sender)
{
//
editSubdivision->Visible = (comboSeed->ItemIndex == 3);
labSubdivision->Visible  = (comboSeed->ItemIndex == 3);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::chkMirrorClick(TObject *Sender)
{
chkAdjustPull->Visible = (!chkMirror->Checked);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SelectionItemClick(TObject *Sender)
{
//
TMenuItem *menuItem = static_cast <TMenuItem*>(Sender);
if (menuItem == selLasso)
   PaintView->MouseInteract = TIEMouseInteract()<<miSelectLasso;
else if (menuItem == selPoly)
   PaintView->MouseInteract = TIEMouseInteract()<<miSelectPolygon;
else
   PaintView->MouseInteract = TIEMouseInteract()<<miSelectCircle;
menuItem->Checked = true;
currMI = PaintView->MouseInteract;
}
//---------------------------------------------------------------------------
bool __fastcall TForm1::processSeed(void)
{
if (!paca)
   paca = new TPaca(srcMap, dstMap);
for (int i = 0; i < 9; i++)
	creationOps[i] = caCreation[i]->Tag;
int seedStyle;
switch (comboSeed->ItemIndex)
  {
  case 0:
	   seedStyle = SEED_EXTREMA_H;
	   break;
  case 1:
	   seedStyle = SEED_EXTREMA_V;
	   break;
  case 2:
	   seedStyle = SEED_EXTREMA_HV;
	   break;
  case 3:
	   seedStyle = SEED_GRID_FULL;
	   break;
  default:
	   seedStyle = SEED_GRID_NOC;
	   break;
  }
bool adjustPull = (chkAdjustPull->Checked && !chkMirror->Checked);
paca->Prepare(maskMap, hardMaskMap, &selRect);
if (paca->Seed(seedStyle, editSubdivision->Value, editSourcePush->Value, editTargetPull->Value, adjustPull ))
   {
   PaintView->RemoveAllObjects();
   int hobj;
   _gripSize = 10;
   int hM1 = srcMap->Height - 1;
   for (int k = 0; k < paca->SiteCount; k++)
	   {
	   if (!paca->SourceSite[k].valid)
		  continue;
	   hobj = PaintView->AddNewObject();
	   PaintView->ObjKind[hobj]  = iekLINE;
	   PaintView->ObjPenColor[hobj] = clBlue;
	   PaintView->ObjPenWidth[hobj] = 2;
	   PaintView->ObjLeft[hobj] = paca->TargetSite[k].x;
	   PaintView->ObjTop[hobj] = (hM1 - paca->TargetSite[k].y);
	   PaintView->ObjWidth[hobj] = paca->SourceSite[k].x - PaintView->ObjLeft[hobj];
	   PaintView->ObjHeight[hobj] = (hM1 - paca->SourceSite[k].y) - PaintView->ObjTop[hobj];
	   PaintView->ObjID[hobj] = k;
	   PaintView->ObjName[hobj] = "line";
	   }
   for (int k = 0; k < paca->SiteCount; k++)
	   {
	   if (!paca->TargetSite[k].valid)
		  continue;
	   hobj = PaintView->AddNewObject();
	   PaintView->ObjKind[hobj]  = iekELLIPSE;
	   PaintView->ObjWidth[hobj] = _gripSize;
	   PaintView->ObjHeight[hobj] = _gripSize;
	   PaintView->ObjPenColor[hobj] = clYellow;
	   PaintView->ObjBrushColor[hobj] = clRed;
	   PaintView->ObjBrushStyle[hobj] = bsSolid;
	   PaintView->ObjLeft[hobj] = paca->TargetSite[k].x - (_gripSize>>1);
	   PaintView->ObjTop[hobj] = (hM1 - paca->TargetSite[k].y) - (_gripSize>>1);
	   PaintView->ObjID[hobj] = k;
	   PaintView->ObjName[hobj] = "target";
	   }
   for (int k = 0; k < paca->SiteCount; k++)
	   {
	   if (!paca->SourceSite[k].valid)
		  continue;
	   hobj = PaintView->AddNewObject();
	   PaintView->ObjKind[hobj]  = iekELLIPSE;
	   PaintView->ObjWidth[hobj] = _gripSize;
	   PaintView->ObjHeight[hobj] = _gripSize;
	   PaintView->ObjPenColor[hobj] = clWhite;
	   PaintView->ObjBrushColor[hobj] = clGreen;
	   PaintView->ObjBrushStyle[hobj] = bsSolid;
	   PaintView->ObjLeft[hobj] = paca->SourceSite[k].x - (_gripSize>>1);
	   PaintView->ObjTop[hobj] = (hM1 - paca->SourceSite[k].y) - (_gripSize>>1);
	   PaintView->ObjID[hobj] = k;
	   PaintView->ObjName[hobj] = "source";
	   }
   PaintView->MouseInteract = TIEMouseInteract();
   PaintView->MouseInteractVt = TIEMouseInteractVt();
   PaintView->OnMouseDown = PaintViewMouseDown;
   PaintView->OnMouseMove = PaintViewMouseMove;
   PaintView->OnMouseUp = PaintViewMouseUp;
   PaintView->PopupMenu = 0;
   _manualSeedDone = false;
   return true;
   }
return false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PaintViewMouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift,
		  int X, int Y)
{
// move object under cursor
_mouseDown = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PaintViewMouseMove(TObject *Sender, TShiftState Shift, int X,
		  int Y)
{
// move or select object
X = PaintView->XScr2Bmp(X);
Y = PaintView->YScr2Bmp(Y);
if (_mouseDown)
   {
   if (_gripIdxSource > -1)
	  {
	  PaintView->ObjTop[_gripIdxSource]  = Y - (_gripSize>>1);
	  PaintView->ObjLeft[_gripIdxSource] = X - (_gripSize>>1);
	  // lines are created first
	  for (int i = 0; i < paca->SiteCount; i++)
		  {
		  if (PaintView->ObjName[i] == "line" && PaintView->ObjID[i] == PaintView->ObjID[_gripIdxSource])
			 {
			 PaintView->ObjHeight[i] = Y - PaintView->ObjTop[i];
			 PaintView->ObjWidth[i]  = X - PaintView->ObjLeft[i];
			 }
		  }
	  _manualSeedDone = true;
	  }
   else if (_gripIdxTarget > -1)
	  {
	  PaintView->ObjTop[_gripIdxTarget]  = Y - (_gripSize>>1);
	  PaintView->ObjLeft[_gripIdxTarget] = X - (_gripSize>>1);
	  // lines are created first
	  for (int i = 0; i < paca->SiteCount; i++)
		  {
		  if (PaintView->ObjName[i] == "line" && PaintView->ObjID[i] == PaintView->ObjID[_gripIdxTarget])
			 {
			 int sX;
			 int sY;
			 for (int j = 0; j <  PaintView->ObjectsCount; j++)
				 {
				 if (PaintView->ObjName[j] == "source" && PaintView->ObjID[i] == PaintView->ObjID[j])
					{
					sX = PaintView->ObjLeft[j] + (_gripSize>>1);
					sY = PaintView->ObjTop[j]  + (_gripSize>>1);
					break;
					}
				 }
			 PaintView->ObjTop[i]   = Y;
			 PaintView->ObjLeft[i]  = X;
			 PaintView->ObjWidth[i]  = sX - X;
			 PaintView->ObjHeight[i] = sY - Y;
			 }
		  }
	  _manualSeedDone = true;
	  }
   }
else
   {
   _gripIdxSource = selectSiteGrip(X, Y, "source");
   _gripIdxTarget = selectSiteGrip(X, Y, "target");
   if (_gripIdxSource > -1 || _gripIdxTarget > -1)
	  PaintView->Cursor = crHandPoint;
   else
	  PaintView->Cursor = defaultCursor;
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PaintViewMouseUp(TObject *Sender, TMouseButton Button, TShiftState Shift,
		  int X, int Y)
{
// release
_mouseDown = false;
}
//---------------------------------------------------------------------------
int __fastcall  TForm1::selectSiteGrip(int X, int Y, UnicodeString objName)
{
int i;
TPoint objPt;
for (i = 0; i < PaintView->ObjectsCount; i++)
	{
	if (PaintView->ObjName[i] != objName)
	   continue;
	objPt.x = PaintView->ObjLeft[i];
	objPt.y = PaintView->ObjTop[i];
	if ((abs(objPt.x - X) <= _gripSize) && (abs(objPt.y - Y) <= _gripSize))
	   return i;
	}
return -1;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnSelectClick(TObject *Sender)
{
//
PaintView->RemoveAllObjects();
PaintView->MouseInteractVt = TIEMouseInteractVt();
PaintView->MouseInteract = currMI;
PaintView->OnMouseDown = 0;
PaintView->OnMouseMove = 0;
PaintView->OnMouseUp = 0;
_manualSeedDone = false;
PaintView->PopupMenu = popSelection;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::chkManualClick(TObject *Sender)
{
//
if (chkManual->Checked)
   {
   btnSelect->Visible = true;
   btnSeed->Visible = true;
   }
else
   {
   btnSelectClick(this);
   btnSelect->Visible = false;
   btnSeed->Visible = false;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::prepareMask(void)
{
PaintView->LockPaint();
// mask without feather
if (editSelectionFeather->Value)
   {
   hardMaskMap = new TIEBitmap();
   hardMaskMap->CopyFromTIEMask(PaintView->SelectionMask);
   }
else
   hardMaskMap = 0;
PaintView->SaveSelection();
PaintView->MakeSelectionFeather(editSelectionFeather->Value);
// feather mask
maskMap = new TIEBitmap();
maskMap->CopyFromTIEMask(PaintView->SelectionMask);
// set bounding rectangle
selRect.left    = PaintView->SelectedRect.x;
selRect.bottom  = srcMap->Height - PaintView->SelectedRect.y;
selRect.right   = selRect.left + PaintView->SelectedRect.width;
selRect.top     = selRect.bottom - PaintView->SelectedRect.height;
PaintView->RestoreSelection();
PaintView->UnLockPaint();
}
//---------------------------------------------------------------------------

