//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
#include "paca.h"
//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.StdCtrls.hpp>
#include <Vcl.Forms.hpp>
#include "ievect.hpp"
#include "ieview.hpp"
#include "imageenview.hpp"
#include <Vcl.ExtCtrls.hpp>
#include "ieopensavedlg.hpp"
#include "spadeSurfaceIen.h"
#include "cspin.h"
#include <Vcl.ComCtrls.hpp>
#include <Vcl.Menus.hpp>
struct structSweepCollection
   {
   int nSL;
   TPoint *sL;
   };
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
	TPanel *Panel1;
	TButton *btnLoad;
	TButton *btnInpaint;
	TImageEnVect *PaintView;
	TOpenImageEnDialog *OpenDialog;
	TButton *btnUndo;
	TCheckBox *chkMirror;
	TLabel *Label1;
	TCSpinEdit *editSourcePush;
	TLabel *labSubdivision;
	TCSpinEdit *editSubdivision;
	TLabel *Label3;
	TPanel *panCaCreation;
	TPanel *Panel2;
	TPanel *Panel3;
	TPanel *Panel4;
	TLabel *Label4;
	TComboBox *comboMatrixMutation;
	TLabel *Label7;
	TCSpinEdit *editMutateStep;
	TLabel *Label6;
	TComboBox *comboDistance;
	TComboBox *comboSeed;
	TCheckBox *chkFillHoles;
	TLabel *Label9;
	TCSpinEdit *editMaxIter;
	TLabel *Label10;
	TLabel *Label8;
	TCSpinEdit *editTargetPull;
	TCheckBox *chkAdjustPull;
	TLabel *Label2;
	TCSpinEdit *editCollisionPass;
	TButton *btnSave;
	TLabel *Label5;
	TComboBox *comboPixelOutput;
	TCheckBox *chkOnionPeel;
	TPanel *Panel5;
	TPanel *panStatus;
	TSaveImageEnDialog *SaveDialog;
	TPopupMenu *popSelection;
	TMenuItem *selLasso;
	TMenuItem *selPoly;
	TMenuItem *selEllipse;
	TButton *btnSeed;
	TButton *btnSelect;
	TCheckBox *chkManual;
	TCheckBox *chkVarProbability;
	TLabel *Label12;
	TCSpinEdit *editBorderSmooth;
	TLabel *Label11;
	TCSpinEdit *editSelectionFeather;
	void __fastcall btnLoadClick(TObject *Sender);
	void __fastcall btnInpaintClick(TObject *Sender);
	void __fastcall btnUndoClick(TObject *Sender);
	void __fastcall comboSeedChange(TObject *Sender);
	void __fastcall chkMirrorClick(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall btnSaveClick(TObject *Sender);
	void __fastcall SelectionItemClick(TObject *Sender);
	void __fastcall btnSeedClick(TObject *Sender);
	void __fastcall PaintViewMouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift,
          int X, int Y);
	void __fastcall PaintViewMouseMove(TObject *Sender, TShiftState Shift, int X, int Y);
	void __fastcall PaintViewMouseUp(TObject *Sender, TMouseButton Button, TShiftState Shift,
          int X, int Y);
	void __fastcall btnSelectClick(TObject *Sender);
	void __fastcall chkManualClick(TObject *Sender);

private:	// User declarations
	TPanel *caCreation[9];
	UnicodeString caLogic[5];
	int creationOps[9];
	TIEBitmap *srcMap, *dstMap, *maskMap, *hardMaskMap, *undoMap;
	TRect selRect;
	TPaca *paca;
	BYTE hardMaskByte;
	TIEMouseInteract currMI;
	TCursor defaultCursor;
	int _gripIdxTarget, _gripIdxSource, _gripSize;
	bool _mouseDown, _manualSeedDone;
	bool __fastcall processInpaint(void);
	bool __fastcall processSeed(void);
	void __fastcall caLogicClick(TObject *Sender);
	int __fastcall  selectSiteGrip(int X, int Y, UnicodeString objName);
	void __fastcall prepareMask(void);
public:		// User declarations
	__fastcall TForm1(TComponent* Owner);
	__fastcall ~TForm1(void);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
