//---------------------------------------------------------------------------
#ifndef pacaH
#define pacaH
//#include "spadeSurfaceIen.h"
#include "seed.h"
//---------------------------------------------------------------------------
struct structSite
   {
   int x;
   int y;
   //long min_quadrance;
   int pair_x;
   int pair_y;
   BYTE BGR[3];
   bool valid;
   TWalkDirection inDirection;
   TWalkDirection outDirection;
   };
struct structCaLogic
   {
   BYTE Container[8];
	//TPoint Center;
	//TPoint Neighbour[8];
	bool Result;
	int Count;
	};
struct structSiteExplore
   {
   int X;
   int Y;
   int k;
   float fBGR[3];
   float fStrength;
   int SiteIndex;
   };
struct structPacaMap
   {
   int **X;	    // w*h
   int **Y;     // w*h
   int **Iteration; // w*h
   int **SiteIndex; // w.h
   float **InpStrength; // w*h
   float **OutStrength; // w*h
   // itd...
   };
const int N33I[8] = {-1, -1, -1, 0, 0, 1, 1, 1};
const int N33J[8] = {-1, 0, 1, -1, 1, -1, 0, 1};
const int mirrN33I[8] = {1, 1, 1, 0, 0, -1, -1, -1};
const int mirrN33J[8] = {1, 0, -1, 1, -1, 1, 0, -1};
const int OPS_pos[9] = {5, 6, 7, 3, 0, 4, 0, 1, 2};
const int PROGRESS_UD[4] = {1, -1, 0, 0};  // remove
const int PROGRESS_LR[4] = {0, 0, 1, -1};  // remove
const int STITCHY[8] = {3, 4, 1, 6, 0, 7, 2, 5};
const float OPS_TOLERANCE =  0.0001;
// luminance
const float OPS_LUMINANCE[3] = {0.11, 0.59, 0.30};
const float OPS_INIT_STRENGTH = 1.0;
const float OPS_INCR_STRENGTH = 0.1;
const float N33_STRENGTH[8] = {0.1, 0.2, 0.1, 1.0, 1.0, 0.1, 0.2, 0.1};
const float N33_GAUSS[8]    = {0.25, 0.5, 0.25, 0.5, 0.5, 0.25, 0.5, 0.25};
// control bytes
const BYTE CTRL_UNMASKED = 0x01;
const BYTE CTRL_PARTIALLY_MASKED = 0x02;
const BYTE CTRL_MASKED   = 0x04;
const BYTE CTRL_SOURCE = 0x08;
const BYTE CTRL_TARGET = 0x10;
const BYTE CTRL_STITCHED = 0x20;
//
//enum TWalkDirection {wUp, wDown, wLeft, wRight, wUpLeft, wUpRight, wDownLeft, wDownRight};
typedef void __fastcall (__closure *TCaMutation)(int *ops);
typedef int __fastcall (__closure *TOutputPixel)(int neighbour_count);
typedef float __fastcall (__closure *TGetDistance)(float *, float *);
//---------------------------------------------------------------------------
class TPaca
{
private:
	TSeed *seedObj;
	structSite *targetSite,*sourceSite;
	int *targetDistrib;
	structPacaMap pacaMap;
	TIEBitmap *controlInput, *controlOutput, *controlSwap;
	TSpadeSurfaceBasic *srcSurface, *dstSurface, *maskSurface;
	TSpadeSurfaceBasic *controlInputSurface, *controlOutputSurface;
	int imgWidth, imgHeight, imgWidthM1, imgHeightM1, targetArea, targetSitesCount;
	int cellX, cellY, siteCount, mutateCreationStep, pushValue, pullValue, averageAdjust;
	int executionPass, outSiteIndex, maxProbability;
	bool sourceSiteCreated, targetSiteCreated, varProbability;
	TRect targetRect, sourceRect, *selRect;
	structCaLogic createLogic[5];
	int creationOps[9], inputCreationOps[9];
	structSiteExplore targetNbh[8], sourceNbh[8], targetCentral, sourceCentral;
	int   iCoordX, iCoordY;
	const int *dispN33I, *dispN33J;
	float fMaxStrength, fCumulStrength;
	BYTE  hardMaskByte;
	TCaMutation mutateCreation;
	TOutputPixel doPixelOutput;
	TGetDistance getDistance;
	void __fastcall deleteSites(void);
	bool __fastcall walkAround(int *y, int *x, TWalkDirection direction, BYTE cByte, int addY, int addX);
	void __fastcall translateAround(int *y, int *x, TWalkDirection direction, BYTE cByte, int addY, int addX);
	void __fastcall seedTarget(int addY, int addX, bool autoAdjustPull);
	void __fastcall seedSource(int addY, int addX);
	void __fastcall validateSites(bool removeTarget);
	int __fastcall exploreHoleNeighbour(int i, int j, BYTE cByte);
	int __fastcall exploreSiteNeighbour(int i, int j, BYTE cByte);
	int __fastcall exploreBorderNeighbour(int i, int j, BYTE cByte);
	void __fastcall swapControlImages(void);
	void __fastcall resetLogicContainer(void);
	void __fastcall addLogicContainer(structCaLogic *logic, int index, bool v1);
	bool __fastcall calculateLogicContainer(structCaLogic *logic);
	int __fastcall exploreTargetNeighbour(int i, int j);
	bool __fastcall doCreation(int i, int j, int neighbour_count);
	bool __fastcall getSourceCoords(int neighbour_count, BYTE cByte);
	void __fastcall processCA(void);
	void __fastcall nopOps(int *ops);
	void __fastcall rotateOps(int *ops);
	void __fastcall shuffleOps(int *ops);
	void __fastcall createPacaMap(void);
	void __fastcall deletePacaMap(void);
	float __fastcall getLuminance(float *fBgr);
	float __fastcall getLumaDistance(float *fBgr1, float *fBgr2);
	float __fastcall getEuclidDistance(float *fBgr1, float *fBgr2);
	int __fastcall getStrongestOne(int neighbour_count);
	void __fastcall calculateStrength(int i, int j, int neighbour_count, float *fBGR);
	int __fastcall setOutputPixelAverage(int neighbour_count);
	int __fastcall setOutputPixelConvolve(int neighbour_count);
	int __fastcall setOutputPixelStrongest(int neighbour_count);
	int __fastcall setOutputPixelWeightedSum(int neighbour_count);
	void __fastcall setOutputPixel(int i, int j, float dstWeight);
	void __fastcall resetControlSurface(BYTE reset);
	int __fastcall getSiteIndex(int i, int j, int neighbour_count);
	void __fastcall copyDst2Src(void);
	bool __fastcall fillHoles(int **outSiteIndex);
	bool __fastcall combineSites(int **outSiteIndex, int iterations);
	bool __fastcall smoothBorder(int sF);
public:
	__fastcall TPaca(TIEBitmap *src, TIEBitmap *dst);
	virtual __fastcall ~TPaca(void);
	void __fastcall Prepare(TIEBitmap *mask, TIEBitmap *hardMaskMap, TRect *pSelRect);
	bool __fastcall Seed(int pSeedStyle, int pDivision, int pPushValue, int pPullValue, bool pAutoAdjustPull);
	bool __fastcall ReseedManual(TPoint *targetSeed, TPoint *sourceSeed);
	bool __fastcall OnionPeel(void);
	bool __fastcall Execute(int maxIterations, bool mirror, int pOutputPixelMode, int pDistanceMode,
							int *pCreationOps, int pMutateIndex, int pMutateStep, bool pVarProbability);
	bool __fastcall PostProcess(bool pFillHoles, int pPropagateStrength, int pSelectionFeather);
	__property int AverageAdjustment = {read = averageAdjust};
	__property int SiteCount = {read = siteCount};
	__property structSite* TargetSite  = {read = targetSite};
	__property structSite* SourceSite  = {read = sourceSite};
};
#endif
