//---------------------------------------------------------------------------
#ifndef seedH
#define seedH
#include "spadeSurfaceIen.h"
const int SEED_EXTREMA_H  = 0;
const int SEED_EXTREMA_V  = 1;
const int SEED_EXTREMA_HV = 2;
const int SEED_GRID_NOC = 4;
const int SEED_GRID_FULL = 5;
// put it in some global constant header
const BYTE SD_UMPM	 = 0x03;
const BYTE SD_MASKED = 0x04;
//const BYTE SD_UMPM	 = 0x01;
//const BYTE SD_MASKED = 0x02;
//
enum TWalkDirection {wUp, wDown, wLeft, wRight, wUpLeft, wUpRight, wDownLeft, wDownRight};
enum TSweepType {sVertical, sHorizontal, sBoth};
typedef bool __fastcall (__closure *TSweepLoopCondition)(int i);
struct TSeedPoint
	{
	int x;
	int y;
	TWalkDirection sweepDirection;
	TWalkDirection walkDirection;
	};
//---------------------------------------------------------------------------
class TSeed
{
private:
	TObjectList *outputPts;
	//nt outputCurCount;
	TSweepLoopCondition sweepLoopCondition, sweepLineCondition;
	TRect *targetRect;
	TSpadeSurfaceBasic *maskSurface, *controlSurface;
	float cellX, cellY;
	int gridDivision;
	BYTE hardMaskByte;
	void __fastcall gridSeed(bool excludeCorners);
	void __fastcall sweepMask(TWalkDirection dir);
	void __fastcall sweepLineExam(TWalkDirection dir, int lp, int fix, bool *sweepLine, TObjectList *extremaPts);
	bool __fastcall sweepRight(int i);
	bool __fastcall sweepLeft(int i);
	bool __fastcall sweepDown(int i);
	bool __fastcall sweepUp(int i);
public:
	__fastcall TSeed(TSpadeSurfaceBasic *pMaskSurface, TSpadeSurfaceBasic *pControlSurface,  TRect *pMaskRect, BYTE pHardMaskByte);
	virtual __fastcall ~TSeed(void);
	void __fastcall Clear(void);
	bool __fastcall Seed(int pDivision, int pSeedStyle);
	void __fastcall SweepSelection(TSweepType type);
	__property TObjectList *SeedList = {read = outputPts};
};
#endif
