//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "spadeSurfaceBasic.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
// Surface
//
// Base class
//
// Author: Sinia Petri
// You may freely distribute, copy, cut and paste this code, as long as...whatever.
//---------------------------------------------------------------------------
__fastcall TSpadeSurfaceBasic::TSpadeSurfaceBasic(void)
{
DirectRGB = 0;
DirectBGR = 0;
DirectByte = 0;
DirectFloat = 0;
DirectBGRFloat = 0;
DirectAlpha = 0;
Options.PixelOverFlow = eopBorder;
}
//---------------------------------------------------------------------------
// destructor
__fastcall TSpadeSurfaceBasic::~TSpadeSurfaceBasic(void)
{
if (DirectRGB)
   delete []DirectRGB;
if (DirectBGR)
   delete []DirectBGR;
if (DirectByte)
   delete []DirectByte;
if (DirectFloat)
   delete []DirectFloat;
if (DirectBGRFloat)
   delete []DirectBGRFloat;
if (DirectAlpha)
   delete []DirectAlpha;
}
//---------------------------------------------------------------------------
UnicodeString __fastcall TSpadeSurfaceBasic::ClassName(void)
{
return "TSpadeSurfaceBasic";
}
//---------------------------------------------------------------------------
// protected members
//---------------------------------------------------------------------------
bool __fastcall TSpadeSurfaceBasic::createSurface(  int width,
													int height,
													int channels,
													int bitsPerChannel,
													ssbImageOrientation imageOrientation,
													ssbColorLayout colorLayout,
													int scanlineAlignment,
													LPVOID mapPointer,
													LPVOID alphaPointer
													)
{
FImageInfo.width = width;
FImageInfo.height = height;
FImageInfo.channels = channels;
FImageInfo.bitsPerChannel = bitsPerChannel;
FImageInfo.imageOrientation = imageOrientation;
FImageInfo.colorLayout = colorLayout;
FImageInfo.scanlineAlignment = scanlineAlignment;
FImageInfo.mapPointer = mapPointer;
FImageInfo.alphaPointer = alphaPointer;
//
long scanline = width * channels * (bitsPerChannel>>3);
long align = scanline % scanlineAlignment;         // pronaimo align
if (align > 0) align =  scanlineAlignment - align;
scanline = scanline + align; 					   // duina scanline-a
FImageInfo.alignL = align;
FImageInfo.scanlineL = scanline;
// pumpa!!!
int i;
if (alphaPointer)
   {
   long scanline_alpha = width;
   long align_alpha = scanline_alpha % scanlineAlignment;         // pronaimo align
   if (align_alpha > 0) align_alpha =  scanlineAlignment - align_alpha;
   scanline_alpha = scanline_alpha + align_alpha;
   DirectAlpha = new BYTE *[height];
   LPBYTE currPtr = (LPBYTE)alphaPointer;
   //TODO: topLeft
   for (i = 0; i < height; i++)
	   {
	   DirectAlpha[i] = (BYTE*) currPtr;
	   currPtr = currPtr + scanline_alpha;
	   }
   }
if (channels == 3 && bitsPerChannel == 8)
   {
   if (colorLayout == cllBGR)
	  {
	  DirectBGR = new TSpadeBGR *[height];
	  LPBYTE currPtr = (LPBYTE)mapPointer;
	  //TODO: topLeft
	  for (i = 0; i < height; i++)
		  {
		  DirectBGR[i] = (TSpadeBGR*) currPtr;
		  currPtr = currPtr + scanline;
		  }
	  }
   else if (colorLayout == cllRGB)
	  {
	  DirectRGB = new TSpadeRGB *[height];
	  LPBYTE currPtr = (LPBYTE)mapPointer;
	  //TODO: topleft
	  for (i = 0; i < height; i++)
		  {
		  DirectRGB[i] = (TSpadeRGB*) currPtr;
		  currPtr = currPtr + scanline;
		  }
	  }
   else
	  return false;
   }
else if (channels == 1 && bitsPerChannel == 8)
   {
   DirectByte = new BYTE *[height];
   LPBYTE currPtr = (LPBYTE)mapPointer;
   for (i = 0; i < height; i++)
	   {
	   DirectByte[i] = (BYTE*) currPtr;
	   currPtr = currPtr + scanline;
	   }
   }
else if (channels == 1 && bitsPerChannel == 32)
   {
   DirectFloat = new float *[height];
   //float *currPtr = (float *)mapPointer;
   LPBYTE currPtr = (LPBYTE)mapPointer;
   for (i = 0; i < height; i++)
	   {
	   DirectFloat[i] = (float*) currPtr;
	   currPtr = currPtr + scanline;
	   }
   }
else if (channels == 3 && bitsPerChannel == 32)
   {
   DirectBGRFloat = new TSpadeBGRFloat *[height];
   float *currPtr = (float *)mapPointer;
   for (i = 0; i < height; i++)
	   {
	   DirectBGRFloat[i] = (TSpadeBGRFloat*) currPtr;
	   currPtr = currPtr + scanline;
	   }
   }
else if (channels == 1 && bitsPerChannel == 16)
   {
   DirectShort = new unsigned short *[height];
   //unsigned short *currPtr = (unsigned short *)mapPointer;
   LPBYTE currPtr = (LPBYTE)mapPointer;
   for (i = 0; i < height; i++)
	   {
	   DirectShort[i] = (unsigned short*) currPtr;
	   currPtr = currPtr + scanline;
	   }
   }
else
   return false;
return true;
}
//---------------------------------------------------------------------------
TSpadeRGB __fastcall TSpadeSurfaceBasic::getPixelRGB(int index, int jndex)
{
if (SetSafeIndex(&index, &jndex) == 2)
   {
   TSpadeRGB retValue;
   retValue.r = retValue.g = retValue.b= 0x00;
   return retValue;
   }
else
   return DirectRGB[index][jndex];
}
//---------------------------------------------------------------------------
TSpadeBGR __fastcall TSpadeSurfaceBasic::getPixelBGR(int index, int jndex)
{
if (SetSafeIndex(&index, &jndex) == 2)
   {
   TSpadeBGR retValue;
   retValue.bgr[0] = retValue.bgr[1] = retValue.bgr[2]= 0x00;
   return retValue;
   }
else
   return DirectBGR[index][jndex];
}
//---------------------------------------------------------------------------
BYTE __fastcall TSpadeSurfaceBasic::getPixelByte(int index, int jndex)
{
if (SetSafeIndex(&index, &jndex) == 2)
   return 0x00;
else
   return DirectByte[index][jndex];
}
//---------------------------------------------------------------------------
float __fastcall TSpadeSurfaceBasic::getPixelFloat(int index, int jndex)
{
if (SetSafeIndex(&index, &jndex) == 2)
   return 0;
else
   return DirectFloat[index][jndex];
}
//---------------------------------------------------------------------------
TSpadeBGRFloat __fastcall TSpadeSurfaceBasic::getPixelBGRFloat(int index, int jndex)
{
if (SetSafeIndex(&index, &jndex) == 2)
   {
   TSpadeBGRFloat retValue;
   retValue.bgr[0] = retValue.bgr[1] = retValue.bgr[2]= 0;
   return retValue;
   }
else
   return DirectBGRFloat[index][jndex];
}
//---------------------------------------------------------------------------
void __fastcall TSpadeSurfaceBasic::setPixelRGB(int index, int jndex, TSpadeRGB value)
{
if (SetSafeIndex(&index, &jndex) == 2)
   return;
else
   {
   DirectRGB[index][jndex].r = value.r;
   DirectRGB[index][jndex].g = value.g;
   DirectRGB[index][jndex].b = value.b;
   }
}
//---------------------------------------------------------------------------
void __fastcall TSpadeSurfaceBasic::setPixelBGR(int index, int jndex, TSpadeBGR value)
{
if (SetSafeIndex(&index, &jndex) == 2)
   return;
else
   {
   DirectBGR[index][jndex].bgr[0] = value.bgr[0];
   DirectBGR[index][jndex].bgr[1] = value.bgr[1];
   DirectBGR[index][jndex].bgr[2] = value.bgr[2];
   }
}
//---------------------------------------------------------------------------
void __fastcall TSpadeSurfaceBasic::setPixelByte(int index, int jndex, BYTE value)
{
if (SetSafeIndex(&index, &jndex) == 2)
   return;
else
   DirectByte[index][jndex] = value;
}
//---------------------------------------------------------------------------
void __fastcall TSpadeSurfaceBasic::setPixelFloat(int index, int jndex, float value)
{
if (SetSafeIndex(&index, &jndex) == 2)
   return;
else
   DirectFloat[index][jndex] = value;
}
//---------------------------------------------------------------------------
void __fastcall TSpadeSurfaceBasic::setPixelBGRFloat(int index, int jndex, TSpadeBGRFloat value)
{
if (SetSafeIndex(&index, &jndex) == 2)
   return;
else
   {
   DirectBGRFloat[index][jndex].bgr[0] = value.bgr[0];
   DirectBGRFloat[index][jndex].bgr[1] = value.bgr[1];
   DirectBGRFloat[index][jndex].bgr[2] = value.bgr[2];
   }
}
//---------------------------------------------------------------------------
// public methods
//---------------------------------------------------------------------------
bool __fastcall TSpadeSurfaceBasic::SetSafeIndex(int *index, int *jndex)
{
if (*index >= 0 && *index < FImageInfo.height && *jndex >= 0 && *jndex < FImageInfo.width)
   return true;
if (Options.PixelOverFlow == eopWrap)
   {
   if (*index < 0)
	 *index = FImageInfo.height + *index;
   else if ( *index >= FImageInfo.height)
	 *index =  *index - FImageInfo.height;
   if (*jndex < 0)
	 *jndex = FImageInfo.width + *jndex;
   else if ( *jndex >= FImageInfo.width)
	 *jndex =  *jndex - FImageInfo.width;
   }
else if (Options.PixelOverFlow == eopBorder)
  {
  if (*index < 0)
	 *index = 0;
  else if ( *index >= FImageInfo.height)
	 *index =  FImageInfo.height - 1;
  if (*jndex < 0)
	 *jndex = 0;
  else if ( *jndex >= FImageInfo.width)
	 *jndex =  FImageInfo.width - 1;
  }
else   //eopSkip
  return false;
return true;
}
//---------------------------------------------------------------------------

