//---------------------------------------------------------------------------
#ifndef spadeSurfaceBasicH
#define spadeSurfaceBasicH
enum ssbImageOrientation {imoBottomlLeft, imoTopLeft };
enum ssbEdgeOptions {eopSkip, eopWrap, eopBorder};
enum ssbColorLayout {cllRGB, cllBGR};
struct TSpadeBGR
   {
   BYTE bgr[3];
   };
struct TSpadeRGB
   {
   BYTE b;
   BYTE g;
   BYTE r;
   };
struct TSpadeBGRFloat
   {
   float bgr[3];
   };
struct TSpadeSurfaceOptions
   {
   ssbEdgeOptions PixelOverFlow;
   };
struct TSpadeSurfaceInfo
   {
   int width;
   int height;
   int channels;
   int bitsPerChannel;
   ssbImageOrientation imageOrientation;
   ssbColorLayout colorLayout;
   int scanlineAlignment;
   LPVOID mapPointer;
   LPVOID alphaPointer;
   // calculated
   long alignL;
   long scanlineL;
   };
//---------------------------------------------------------------------------
class TSpadeSurfaceBasic
{
//TODO: eventualno naslijediti TObject
private:
protected:
	bool __fastcall createSurface(	int width,
									int height,
									int channels,
									int bitsPerChannel,
									ssbImageOrientation imageOrientation,
									ssbColorLayout colorLayout,
									int scanlineAlignment,
									LPVOID mapPointer,
									LPVOID alphaPointer
									);
	// getters
	TSpadeRGB __fastcall getPixelRGB(int index, int jndex);
	TSpadeBGR __fastcall getPixelBGR(int index, int jndex);
	BYTE      __fastcall getPixelByte(int index, int jndex);
	float      __fastcall getPixelFloat(int index, int jndex);
	TSpadeBGRFloat  __fastcall getPixelBGRFloat(int index, int jndex);
	BYTE      __fastcall getPixelAlpha(int index, int jndex);
	// setters
	void __fastcall setPixelRGB(int index, int jndex, TSpadeRGB value);
	void __fastcall setPixelBGR(int index, int jndex, TSpadeBGR value);
	void __fastcall setPixelByte(int index, int jndex, BYTE value);
	void __fastcall setPixelFloat(int index, int jndex, float value);
	void __fastcall setPixelBGRFloat(int index, int jndex, TSpadeBGRFloat value);
	void __fastcall setPixelAlpha(int index, int jndex, BYTE value);
	//
	TSpadeSurfaceInfo FImageInfo;
public:
	__fastcall TSpadeSurfaceBasic(void);
	virtual __fastcall ~TSpadeSurfaceBasic(void);
	virtual UnicodeString __fastcall ClassName(void);
  TSpadeRGB **DirectRGB;
  TSpadeBGR **DirectBGR;
  BYTE **DirectByte;
  BYTE **DirectAlpha;
  float **DirectFloat;
  unsigned short **DirectShort;
  TSpadeBGRFloat **DirectBGRFloat;
  TSpadeSurfaceOptions Options;
  // public methods
  bool __fastcall SetSafeIndex(int *index, int *jndex);
  //
  __property TSpadeSurfaceInfo ImageInfo = {read = FImageInfo};
  // getteri i setteri za pixele
  __property TSpadeRGB SafeRGB[int index][int jndex] = {read = getPixelRGB, write = setPixelRGB};
  __property TSpadeBGR SafeBGR[int index][int jndex] = {read = getPixelBGR, write = setPixelBGR};
  __property BYTE SafeByte[int index][int jndex] = {read = getPixelByte, write = setPixelByte};
  __property float SafeFloat[int index][int jndex] = {read = getPixelFloat, write = setPixelFloat};
  __property TSpadeBGRFloat SafeBgrFloat[int index][int jndex] = {read = getPixelBGRFloat, write = setPixelBGRFloat};
};
#endif

